# TODO:
# Warning: The user account 'oprofile:oprofile' does not exist on the system.
#         To profile JITed code, this special user account must exist.
#         Please ask your system administrator to add the following user and group:
#               user name : 'oprofile'
#               group name: 'oprofile'
#             The 'oprofile' group must be the default group for the 'oprofile' user.
#
Summary:	System-wide profiler
Summary(pl.UTF-8):	Ogólnosystemowy profiler
Name:		oprofile
Version:	1.1.0
Release:	8
License:	GPL v2 (oprofile), LGPL v2.1+ (libopagent)
Group:		Applications/System
Source0:	http://downloads.sourceforge.net/oprofile/%{name}-%{version}.tar.gz
# Source0-md5:	248c4c069f9476f427fa7195563f9867
Patch0:		%{name}-c++.patch
URL:		http://oprofile.sourceforge.net/
# not used directly, but build fails without it
BuildRequires:	autoconf >= 2.50
BuildRequires:	binutils-devel
BuildRequires:	libstdc++-devel
BuildRequires:	linux-libc-headers >= 7:2.6.31
BuildRequires:	popt-devel
BuildRequires:	rpmbuild(macros) >= 1.217
Requires:	uname(release) >= 2.6.31
Conflicts:	kernel < 2.6.31
ExclusiveArch:	alpha arm %{ix86} ia64 mips ppc ppc64 %{x8664} x32
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define	oprofile_arch	%(echo "%{_target_base_arch}" | sed -e 's#x86_64#x86-64#')

%description
It consists of a kernel driver and a daemon for collecting sample
data, and several post-profiling tools for turning data into
information.

OProfile leverages the hardware performance counters of the CPU to
enable profiling of a wide variety of interesting statistics, which
can also be used for basic time-spent profiling. All code is profiled:
hardware and software interrupt handlers, kernel modules, the kernel,
shared libraries, and applications.

%description -l pl.UTF-8
Pakiet składa się ze sterownika dla jądra oraz demona zbierającego
próbki danych, a także kilku narzędzi do postprocesingu,
przekształcających dane na informacje.

OProfile utrzymuje liczniki wydajności sprzętu dla CPU, aby umożliwić
profilowanie wielorakich interesujących statystyk, których można
używać także do podstawowego profilowania czasu wykonywania.
Profilowany jest cały kod: procedury obsługi przerwań sprzętowych i
programowych, moduły jądra, jądro, biblioteki współdzielone oraz
aplikacje.

%package devel
Summary:	Header file for libopagent library
Summary(pl.UTF-8):	Plik nagłówkowy biblioteki libopagent
License:	LGPL v2.1+
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
Header file for libopagent library.

%description devel -l pl.UTF-8
Plik nagłówkowy biblioteki libopagent.

%package static
Summary:	Static libopagent library
Summary(pl.UTF-8):	Statyczna biblioteka libopagent
License:	LGPL v2.1+
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static libopagent library.

%description static -l pl.UTF-8
Statyczna biblioteka libopagent.

%prep
%setup -q
%patch0 -p1

%build
%configure

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_var}/lib/oprofile

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%preun
if [ "$1" = 0 ]; then
	%{_bindir}/opcontrol --shutdown 2>/dev/null 1>&2
	rm -rf %{_var}/lib/oprofile/*
fi

%files
%defattr(644,root,root,755)
%doc ChangeLog* README TODO doc/*.html doc/*.png doc/*.xsd
%attr(755,root,root) %{_bindir}/ocount
%attr(755,root,root) %{_bindir}/opannotate
%attr(755,root,root) %{_bindir}/oparchive
%attr(755,root,root) %{_bindir}/op-check-perfevents
%attr(755,root,root) %{_bindir}/operf
%attr(755,root,root) %{_bindir}/opgprof
%attr(755,root,root) %{_bindir}/ophelp
%attr(755,root,root) %{_bindir}/opimport
%attr(755,root,root) %{_bindir}/opjitconv
%attr(755,root,root) %{_bindir}/opreport
%dir %{_libdir}/oprofile
%attr(755,root,root) %{_libdir}/oprofile/libopagent.so.*.*.*
%attr(755,root,root) %{_libdir}/oprofile/libopagent.so.1
%{_datadir}/%{name}
%dir %{_var}/lib/oprofile
%{_mandir}/man1/ocount.1*
%{_mandir}/man1/opannotate.1*
%{_mandir}/man1/oparchive.1*
%{_mandir}/man1/op-check-perfevents.1*
%{_mandir}/man1/operf.1*
%{_mandir}/man1/opgprof.1*
%{_mandir}/man1/ophelp.1*
%{_mandir}/man1/opimport.1*
%{_mandir}/man1/opreport.1*
%{_mandir}/man1/oprofile.1*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/oprofile/libopagent.so
%{_libdir}/oprofile/libopagent.la
%{_includedir}/opagent.h

%files static
%defattr(644,root,root,755)
%{_libdir}/oprofile/libopagent.a
%changelog
* Mon Jul 23 2018 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/oprofile.git;a=log;h=master

* Mon Jul 23 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 1e66385
- release 8 (by relup.sh)

* Sun Jul 15 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 7ad0477
- release 7 (by relup.sh)

* Mon Feb 26 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 2dce49e
- release 6 (by relup.sh)

* Tue Oct 24 2017 Jan Rękorajski <baggins@pld-linux.org> 65dff18
- rebuild with binutils 2.29
- release 5 (by relup.sh)

* Tue Jun 06 2017 Jakub Bogusz <qboosh@pld-linux.org> 9569170
- added c++ patch (use explicit stream to bool conversion for C++ 11 compatibility); release 4

* Tue Jun 06 2017 Jakub Bogusz <qboosh@pld-linux.org> 8193bc7
- release 3 (rebuild with binutils 2.28)

* Sat Dec 17 2016 Jan Rękorajski <baggins@pld-linux.org> acf1b0c
- rebuild with binutils 2.27
- release 2 (by relup.sh)

* Wed Aug 03 2016 Jakub Bogusz <qboosh@pld-linux.org> b110efa
- updated to 1.1.0

* Mon Mar 14 2016 Jan Rękorajski <baggins@pld-linux.org> ed8172a
- release 5 (by relup.sh)

* Tue Aug 04 2015 Jan Rękorajski <baggins@pld-linux.org> a5819b2
- release 4 (by relup.sh)

* Sun Jun 28 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 9760b2e
- libbfd rebuild
- release 3 (by relup.sh)

* Sat Apr 11 2015 Jan Rękorajski <baggins@pld-linux.org> 0c43d78
- add x32 to build archs
- rel 2

* Sat Apr 11 2015 Jan Rękorajski <baggins@pld-linux.org> 2941073
- updated to 1.0.0

* Sat Apr 11 2015 Jan Rękorajski <baggins@pld-linux.org> c23a8c4
- release 17 (by relup.sh)

* Sat Nov 15 2014 Jan Rękorajski <baggins@pld-linux.org> 5dd615b
- release 16 (by relup.sh)

* Tue Jun 17 2014 Jacek Konieczny <j.konieczny@eggsoft.pl> e274a93
- fix 'without gui' build

* Tue Jan 28 2014 Jan Rękorajski <baggins@pld-linux.org> f5ef975
- release 15 (by relup.sh)

* Wed Jan 22 2014 Jan Rękorajski <baggins@pld-linux.org> 120f771
- release 14 (by relup.sh)

* Tue Dec 03 2013 Jan Rękorajski <baggins@pld-linux.org> bea5e07
- rebuild with binutils 2.24.51.0.1
- release 13 (by relup.sh)

* Thu May 02 2013 Jan Rękorajski <baggins@pld-linux.org> 92dcfc2
- release 12 (by relup.sh)

